// Written by TeTeT, assisted by Dscha
// based on arma 2 code from Eggbeast and dayz code from Rocket

uns_melee_fnc_throwKnife = {
	params ["_thrower", "_tgt", "_type"];

	_thrower removeMagazine _type;
	_tgt addMagazine _type;

	// Anim seems to do not much
	// _thrower switchMove "AmelPercMstpSnonWnonDnon_zasah6hlava";
	_tgt setDamage 1;
	_thrower say "throw";

	_tgt;
};

uns_melee_fnc_stabKnife = {
	params ["_stabber", "_tgt"];

	// Anim seems to do not much
	// _stabber switchMove "AmovPercMrunSrasWrflDf_AmovPercMevaSrasWrflDb";
	_tgt setDamage 1;
	_stabber say "stab";

	_tgt;
};

uns_melee_fnc_stabBayonet = {
	params ["_stabber", "_tgt"];

	// Anim seems to do not much
	// _stabber switchMove "AmovPercMrunSrasWrflDf_AmovPercMevaSrasWrflDb";
	_tgt setDamage 1;
	_stabber say "stab";

	_tgt;
};

uns_melee_fnc_melee = {
	params [["_unit", ObjNull]];

	if (isNull _unit) exitWith {};
	if (!local _unit) exitWith {};

	// maybe there's a better way to get these items from config dynamically?
	private _bayonetClasses = ["uns_b_m40_camo", "uns_b_m70_camo", "Uns_acc_bayo_base", "b_smle_1937",
								"uns_b_spike17", "uns_b_sks", "uns_b_6H3", "uns_b_spike", "uns_b_mas49",
								"uns_b_m1", "uns_b_m4", "uns_b_m6", "uns_b_m7", "uns_b_type30", "uns_b_m1917"];

	private _tgt = cursorTarget;
	private _magazines = magazines _unit;
	// Bayonet support
	private _stabbed = false;
	{
		if (_x in _bayonetClasses and _tgt isKindOf "Man" and _tgt distance _unit < 2 and !_stabbed) then {
			[_unit, _tgt] call uns_melee_fnc_stabBayonet;
			_stabbed = true;
		};
	} forEach primaryWeaponItems _unit;
	// Knife support
	if (("uns_knife" in _magazines or "uns_kabar" in _magazines) and !_stabbed) then {
		if (_tgt isKindOf "Man") then {
			if (_tgt distance _unit < 2) then {
				[_unit, _tgt] call uns_melee_fnc_stabKnife;
				_stabbed = true;
			};
			if (_tgt distance _unit < 10 and !_stabbed) then {
				private _type = "uns_knife";
				if ("uns_kabar" in _magazines) then {
					_type = "uns_kabar";
				};
				[_unit, _tgt, _type] call uns_melee_fnc_throwKnife;
			};
		};
	};

	_unit;
};

[] spawn {
    waitUntil{!isNull findDisplay 46};
    (findDisplay 46) displayAddEventHandler ["KeyDown", { [] call uns_melee_fnc_KeyHandler; }];

    uns_melee_fnc_KeyHandler = {
        params["_ctrl","_button","_BtnShift","_BtnCtrl","_BtnAlt"];
        private _CTarget = cursorTarget;
        private _ButtonDisabled = false;
        private _BD = {_ButtonDisabled = true;};
        // stab or throw on f
        if (_button isEqualTo 33) then {
            if (side group _CTarget != side group player) then {
                [player] call uns_melee_fnc_melee;
                call _BD;
            };
        };
        _ButtonDisabled
    };
};
